// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.adagio.core.dao.referential.pmfm;

/**
 * <p>
 * Un paramètre est une propriété du milieu ou d'un élément du
 * milieu qui contribue à en apprécier les caractéristiques et/ou
 * la qualité et/ou l'aptitude à des usages.
 * </p>
 * <p>
 * Le paramètre se décline en trois types : quantitatif, qualitatif
 * ou libre.
 * </p>
 * <p>
 * Le type quantitatif se rapporte aux paramètres qui ont une
 * infinité de résultats numériques.
 * </p>
 * <p>
 * Le type qualitatif se rapporte aux paramètres qui ne prennent
 * qu'un nombre limité de valeurs prédéfinies pour chacun d'eux.
 * </p>
 * <p>
 * Le type libre, ou alphanumérique, correspond aux paramètres de
 * valeurs alphanumériques, sans limite de valeurs possibles
 * (hormis la longueur de la chaine : 40 max).
 * </p>
 * <p>
 * Ces trois types sont mutuellement exclusifs.
 * </p>
 * <p>
 * Exemple de paramètre :
 * </p>
 * <p>
 * • Taille (numérique)
 * </p>
 * <p>
 * • Age (numérique)
 * </p>
 * <p>
 * • Sexe (qualitatif)
 * </p>
 * <p>
 * • Catégorie commerciale (qualitatif)
 * </p>
 * <p>
 * • Présentation commerciale (qualitatif)
 * </p>
 * <p>
 * • Vrac / Hors Vrac (qualitatif)
 * </p>
 * <p>
 * • Rejet / Débarquement (qualitatif) (Discard/Landing)
 * </p>
 * <p>
 * • Stade de maturité (qualitatif) (Maturity stage)
 * </p>
 * <p>
 * • Numéro de contrat (libre - alphanumérique)
 * </p>
 * <p>
 * Cette liste n’est pas exhaustive.
 * </p>
 * <p>
 * Nombre de lignes : 130
 * </p>
 */
public abstract class Parameter
    implements java.io.Serializable
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = 8577752029076465050L;

    private java.lang.String code;

    /**
     * <p>
     * Code du paramètre
     * </p>
     */
    public java.lang.String getCode()
    {
        return this.code;
    }

    public void setCode(java.lang.String code)
    {
        this.code = code;
    }

    private java.lang.String name;

    /**
     * <p>
     * Libellé du paramètre
     * </p>
     */
    public java.lang.String getName()
    {
        return this.name;
    }

    public void setName(java.lang.String name)
    {
        this.name = name;
    }

    private java.lang.String description;

    /**
     * <p>
     * Description du paramètre
     * </p>
     */
    public java.lang.String getDescription()
    {
        return this.description;
    }

    public void setDescription(java.lang.String description)
    {
        this.description = description;
    }

    private java.lang.Boolean isQualitative;

    /**
     * <p>
     * Indique si pour le paramètre on saisit des valeurs numérique ou
     * si on choisit dans une liste de valeurs qualitatives
     * </p>
     */
    public java.lang.Boolean getIsQualitative()
    {
        return this.isQualitative;
    }

    public void setIsQualitative(java.lang.Boolean isQualitative)
    {
        this.isQualitative = isQualitative;
    }

    private java.lang.Boolean isTaxinomic;

    /**
     * <p>
     * Indique si le paramètre est utilisé pour des mesures de
     * dénombrement
     * </p>
     */
    public java.lang.Boolean getIsTaxinomic()
    {
        return this.isTaxinomic;
    }

    public void setIsTaxinomic(java.lang.Boolean isTaxinomic)
    {
        this.isTaxinomic = isTaxinomic;
    }

    private java.lang.Boolean isCalculated;

    /**
     * <p>
     * Indique si le paramètre est calculé
     * </p>
     */
    public java.lang.Boolean getIsCalculated()
    {
        return this.isCalculated;
    }

    public void setIsCalculated(java.lang.Boolean isCalculated)
    {
        this.isCalculated = isCalculated;
    }

    private java.lang.Boolean isAlphanumeric = java.lang.Boolean.valueOf(false);

    /**
     * <p>
     * <html>
     * </p>
     * <p>
     * <head>
     * </p>
     * <p>
     * <style>
     * </p>
     * <p>
     * p {padding:0px; margin:0px;}
     * </p>
     * <p>
     * </style>
     * </p>
     * <p>
     * </head>
     * </p>
     * <p>
     * <body>
     * </p>
     * <p>
     * <p>
     * </p>
     * <p>
     * Indique si pour le paramètre on saisit des valeurs
     * alphanumérique
     * </p>
     * <p>
     * (=Vrai) ou si on choisit dans une liste de valeurs qualitatives
     * ou si
     * </p>
     * <p>
     * les valeurs sont numérique (=Faux - cf <i>isQualitative</i>)
     * </p>
     * <p>
     * </p>
     * </p>
     * <p>
     * </body>
     * </p>
     * <p>
     * </html>
     * </p>
     */
    public java.lang.Boolean getIsAlphanumeric()
    {
        return this.isAlphanumeric;
    }

    public void setIsAlphanumeric(java.lang.Boolean isAlphanumeric)
    {
        this.isAlphanumeric = isAlphanumeric;
    }

    private java.util.Date creationDate;

    /**
     * 
     */
    public java.util.Date getCreationDate()
    {
        return this.creationDate;
    }

    public void setCreationDate(java.util.Date creationDate)
    {
        this.creationDate = creationDate;
    }

    private java.sql.Timestamp updateDate;

    /**
     * 
     */
    public java.sql.Timestamp getUpdateDate()
    {
        return this.updateDate;
    }

    public void setUpdateDate(java.sql.Timestamp updateDate)
    {
        this.updateDate = updateDate;
    }



    private java.util.Collection<fr.ifremer.adagio.core.dao.referential.pmfm.QualitativeValue> qualitativeValues = new java.util.HashSet<fr.ifremer.adagio.core.dao.referential.pmfm.QualitativeValue>();

    /**
     * 
     */
    public java.util.Collection<fr.ifremer.adagio.core.dao.referential.pmfm.QualitativeValue> getQualitativeValues()
    {
        return this.qualitativeValues;
    }

    public void setQualitativeValues(java.util.Collection<fr.ifremer.adagio.core.dao.referential.pmfm.QualitativeValue> qualitativeValues)
    {
        this.qualitativeValues = qualitativeValues;
    }


    private fr.ifremer.adagio.core.dao.referential.pmfm.ParameterGroup parameterGroup;

    /**
     * 
     */
    public fr.ifremer.adagio.core.dao.referential.pmfm.ParameterGroup getParameterGroup()
    {
        return this.parameterGroup;
    }

    public void setParameterGroup(fr.ifremer.adagio.core.dao.referential.pmfm.ParameterGroup parameterGroup)
    {
        this.parameterGroup = parameterGroup;
    }


    private fr.ifremer.adagio.core.dao.referential.Status status;

    /**
     * <p>
     * état de l'objet (actif ou inactif)
     * </p>
     */
    public fr.ifremer.adagio.core.dao.referential.Status getStatus()
    {
        return this.status;
    }

    public void setStatus(fr.ifremer.adagio.core.dao.referential.Status status)
    {
        this.status = status;
    }



    /**
     * This entity does not have any identifiers
     * and is not extending any other entity,
     * so this method will only return <code>true</code> if the argument reference and <code>this</code>
     * refer to the same object.
     */
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof Parameter))
        {
            return false;
        }
        final Parameter that = (Parameter)object;
        if (this.code == null || that.getCode() == null || !this.code.equals(that.getCode()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (code == null ? 0 : code.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link fr.ifremer.adagio.core.dao.referential.pmfm.Parameter}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link fr.ifremer.adagio.core.dao.referential.pmfm.Parameter}.
         */
        public static fr.ifremer.adagio.core.dao.referential.pmfm.Parameter newInstance()
        {
            final fr.ifremer.adagio.core.dao.referential.pmfm.Parameter entity = new fr.ifremer.adagio.core.dao.referential.pmfm.ParameterImpl();
			return entity;
        }

        /**
         * Constructs a new instance of {@link fr.ifremer.adagio.core.dao.referential.pmfm.Parameter}, taking all required and/or
         * read-only properties as arguments.
         */
        public static fr.ifremer.adagio.core.dao.referential.pmfm.Parameter newInstance(java.lang.String name, java.lang.Boolean isQualitative, java.lang.Boolean isTaxinomic, java.lang.Boolean isCalculated, java.lang.Boolean isAlphanumeric, java.util.Date creationDate, fr.ifremer.adagio.core.dao.referential.pmfm.ParameterGroup parameterGroup, fr.ifremer.adagio.core.dao.referential.Status status)
        {
            final fr.ifremer.adagio.core.dao.referential.pmfm.Parameter entity = newInstance();
            entity.setName(name);
            entity.setIsQualitative(isQualitative);
            entity.setIsTaxinomic(isTaxinomic);
            entity.setIsCalculated(isCalculated);
            entity.setIsAlphanumeric(isAlphanumeric);
            entity.setCreationDate(creationDate);
            entity.setParameterGroup(parameterGroup);
            entity.setStatus(status);
            return entity;
        }

        /**
         * Constructs a new instance of {@link fr.ifremer.adagio.core.dao.referential.pmfm.Parameter}, taking all possible properties
         * (except the identifier(s))as arguments.
         */
        public static fr.ifremer.adagio.core.dao.referential.pmfm.Parameter newInstance(java.lang.String name, java.lang.String description, java.lang.Boolean isQualitative, java.lang.Boolean isTaxinomic, java.lang.Boolean isCalculated, java.lang.Boolean isAlphanumeric, java.util.Date creationDate, java.sql.Timestamp updateDate, java.util.Collection<fr.ifremer.adagio.core.dao.referential.pmfm.QualitativeValue> qualitativeValues, fr.ifremer.adagio.core.dao.referential.pmfm.ParameterGroup parameterGroup, fr.ifremer.adagio.core.dao.referential.Status status)
        {
            final fr.ifremer.adagio.core.dao.referential.pmfm.Parameter entity = newInstance();
            entity.setName(name);
            entity.setDescription(description);
            entity.setIsQualitative(isQualitative);
            entity.setIsTaxinomic(isTaxinomic);
            entity.setIsCalculated(isCalculated);
            entity.setIsAlphanumeric(isAlphanumeric);
            entity.setCreationDate(creationDate);
            entity.setUpdateDate(updateDate);
            entity.setQualitativeValues(qualitativeValues);
            entity.setParameterGroup(parameterGroup);
            entity.setStatus(status);
            return entity;
        }
    }
    
// Parameter.java merge-point
}