// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.adagio.core.dao.data.measure;

/**
 * <p>
 * Valeur mesurée ou analysée sur un individu (résultats de mesures
 * sur individu) appartenant à un prélèvement effectué lors d'un
 * échantillonnage biologique, lors d'une marée, d'un vente ou d'un
 * débarquement observé. Les observations sur le prélèvement sont
 * souvent menées en laboratoire, à terre.
 * </p>
 */
public abstract class SampleMeasurement
    extends fr.ifremer.adagio.core.dao.data.measure.MeasurementImpl
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = 4164573865635600759L;

    private java.lang.Short individualNumber;

    /**
     * <p>
     * Numéro de l'individu sur lequel est effectué la mesure.
     * </p>
     * <p>
     * (quand plusieurs individu ont été comptés, au niveau de
     * l'échantillon)
     * </p>
     */
    public java.lang.Short getIndividualNumber()
    {
        return this.individualNumber;
    }

    public void setIndividualNumber(java.lang.Short individualNumber)
    {
        this.individualNumber = individualNumber;
    }

    private java.lang.Boolean isReferenceMeasurement = java.lang.Boolean.valueOf(true);

    /**
     * <p>
     * Dans le cas de plusieurs résultat de mesure au sein d'un
     * prélèvement sur un meme individu (identifié par le numéro
     * d'individu), cela permet de distinguer la valeur de référence
     * (celle qu'il faudra exploiter) tout en gardant les autres
     * mesure.
     * </p>
     * <p>
     * Exemple :
     * </p>
     * <p>
     * - Pour la leture d'age, plusieurs déterminations d'age sont
     * effectuées, mais une seule est conservée.
     * </p>
     */
    public java.lang.Boolean getIsReferenceMeasurement()
    {
        return this.isReferenceMeasurement;
    }

    public void setIsReferenceMeasurement(java.lang.Boolean isReferenceMeasurement)
    {
        this.isReferenceMeasurement = isReferenceMeasurement;
    }


    private fr.ifremer.adagio.core.dao.data.sample.Sample sample;

    /**
     * 
     */
    public fr.ifremer.adagio.core.dao.data.sample.Sample getSample()
    {
        return this.sample;
    }

    public void setSample(fr.ifremer.adagio.core.dao.data.sample.Sample sample)
    {
        this.sample = sample;
    }

    /**
     * This entity does not have any identifiers
     * but since it extends the <code>fr.ifremer.adagio.core.dao.data.measure.MeasurementImpl</code> class
     * it will simply delegate the call up there.
     *
     * @see fr.ifremer.adagio.core.dao.data.measure.Measurement#equals(Object)
     */
    public boolean equals(Object object)
    {
        return super.equals(object);
    }

    /**
     * This entity does not have any identifiers
     * but since it extends the <code>fr.ifremer.adagio.core.dao.data.measure.MeasurementImpl</code> class
     * it will simply delegate the call up there.
     *
     * @see fr.ifremer.adagio.core.dao.data.measure.Measurement#hashCode()
     */
    public int hashCode()
    {
        return super.hashCode();
    }

    /**
     * Constructs new instances of {@link fr.ifremer.adagio.core.dao.data.measure.SampleMeasurement}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link fr.ifremer.adagio.core.dao.data.measure.SampleMeasurement}.
         */
        public static fr.ifremer.adagio.core.dao.data.measure.SampleMeasurement newInstance()
        {
            final fr.ifremer.adagio.core.dao.data.measure.SampleMeasurement entity = new fr.ifremer.adagio.core.dao.data.measure.SampleMeasurementImpl();
			return entity;
        }

        /**
         * Constructs a new instance of {@link fr.ifremer.adagio.core.dao.data.measure.SampleMeasurement}, taking all required and/or
         * read-only properties as arguments.
         */
        public static fr.ifremer.adagio.core.dao.data.measure.SampleMeasurement newInstance(fr.ifremer.adagio.core.dao.referential.QualityFlag qualityFlag, fr.ifremer.adagio.core.dao.referential.pmfm.Pmfm pmfm, java.lang.Boolean isReferenceMeasurement, fr.ifremer.adagio.core.dao.data.sample.Sample sample)
        {
            final fr.ifremer.adagio.core.dao.data.measure.SampleMeasurement entity = newInstance();
            entity.setQualityFlag(qualityFlag);
            entity.setPmfm(pmfm);
            entity.setIsReferenceMeasurement(isReferenceMeasurement);
            entity.setSample(sample);
            return entity;
        }

        /**
         * Constructs a new instance of {@link fr.ifremer.adagio.core.dao.data.measure.SampleMeasurement}, taking all possible properties
         * (except the identifier(s))as arguments.
         */
        public static fr.ifremer.adagio.core.dao.data.measure.SampleMeasurement newInstance(java.lang.Float numericalValue, java.lang.String alphanumericalValue, java.lang.Integer digitCount, java.lang.Float precisionValue, java.util.Date controlDate, java.util.Date validationDate, java.util.Date qualificationDate, java.lang.String qualificationComments, fr.ifremer.adagio.core.dao.referential.pmfm.QualitativeValue qualitativeValue, fr.ifremer.adagio.core.dao.referential.NumericalPrecision numericalPrecision, fr.ifremer.adagio.core.dao.referential.AnalysisInstrument analysisInstrument, fr.ifremer.adagio.core.dao.administration.user.Department department, fr.ifremer.adagio.core.dao.referential.QualityFlag qualityFlag, fr.ifremer.adagio.core.dao.referential.PrecisionType precisionType, fr.ifremer.adagio.core.dao.referential.pmfm.AggregationLevel aggregationLevel, fr.ifremer.adagio.core.dao.referential.pmfm.Pmfm pmfm, java.lang.Short individualNumber, java.lang.Boolean isReferenceMeasurement, fr.ifremer.adagio.core.dao.data.sample.Sample sample)
        {
            final fr.ifremer.adagio.core.dao.data.measure.SampleMeasurement entity = newInstance();
            entity.setNumericalValue(numericalValue);
            entity.setAlphanumericalValue(alphanumericalValue);
            entity.setDigitCount(digitCount);
            entity.setPrecisionValue(precisionValue);
            entity.setControlDate(controlDate);
            entity.setValidationDate(validationDate);
            entity.setQualificationDate(qualificationDate);
            entity.setQualificationComments(qualificationComments);
            entity.setQualitativeValue(qualitativeValue);
            entity.setNumericalPrecision(numericalPrecision);
            entity.setAnalysisInstrument(analysisInstrument);
            entity.setDepartment(department);
            entity.setQualityFlag(qualityFlag);
            entity.setPrecisionType(precisionType);
            entity.setAggregationLevel(aggregationLevel);
            entity.setPmfm(pmfm);
            entity.setIndividualNumber(individualNumber);
            entity.setIsReferenceMeasurement(isReferenceMeasurement);
            entity.setSample(sample);
            return entity;
        }
    }
    
// SampleMeasurement.java merge-point
}